From 7d6632e95220db8302e6910fad16ddacdd576f4a Mon Sep 17 00:00:00 2001
From: skrzepto <shims506@gmail.com>
Date: Jun 14 2016 16:04:47 +0000
Subject: [PATCH 1/9] pushing my work on unittesting up


---

diff --git a/hubs/tests/__init__.py b/hubs/tests/__init__.py
index e69de29..8dbca6c 100644
--- a/hubs/tests/__init__.py
+++ b/hubs/tests/__init__.py
@@ -0,0 +1,141 @@
+from contextlib import contextmanager
+import json
+from datetime import datetime, timedelta
+
+import munch
+from os.path import dirname
+import unittest
+
+import requests
+import vcr
+
+import hubs.models
+
+cassette_dir = dirname(dirname(__file__)) + '/vcr-request-data/'
+
+
+class APPTest(unittest.TestCase):
+    def setUp(self):
+        filename = cassette_dir + self.id()
+        self.vcr = vcr.use_cassette(filename, record_mode='new_episodes')
+        self.vcr.__enter__()
+
+        import hubs.app
+        hubs.app.fedmsg_config = {
+            'hubs.sqlalchemy.uri': 'sqlite://',  # in memory
+        }
+        hubs.app.session = hubs.models.init(
+            hubs.app.fedmsg_config['hubs.sqlalchemy.uri'],
+            create=True,
+        )
+        self.app = hubs.app.app.test_client()
+        self.app.testing = True
+        self.session = hubs.app.session
+        self.populate()
+
+    def tearDown(self):
+        self.vcr.__exit__()
+        self.session.remove()
+
+    def populate(self):
+        for user in ['devyani7', 'dhrish', 'shalini', 'ralph', 'decause']:
+            openid = '%s.id.fedoraproject.org' % user
+            fullname = user.title()
+            hubs.models.User.get_or_create(
+                hubs.app.session, openid=openid, fullname=fullname)
+
+        hubs.app.session.flush()
+
+        hub = hubs.models.Hub.by_name(hubs.app.session, 'ralph')
+        widget = hubs.models.Widget(
+            plugin='about',
+            index=500,
+            _config=json.dumps({"text": "Testing."}),
+        )
+        hub.widgets.append(widget)
+
+        for team in ['i18n', 'infra', 'old']:
+            hub = hubs.models.Hub(name=team, summary="the %s team" % team)
+            if hub.name == 'old':
+                hub.last_refreshed = datetime.utcnow() - timedelta(days=100)
+                hub.last_updated = datetime.utcnow() - timedelta(days=200)
+
+            hubs.app.session.add(hub)
+            widget = hubs.models.Widget(plugin='meetings', index=11,
+                                        _config=json.dumps({'calendar': team}))
+            hub.widgets.append(widget)
+        hubs.app.session.commit()
+
+    # TODO - test that it is in the registry
+    # TODO - test that it has all the things it needs
+
+    def widget_instance(self, hubname, plugin):
+        hub = hubs.models.Hub.by_name(self.session, hubname)
+        if not hub:
+            raise ValueError("No such hub %r" % hubname)
+        for widget in hub.widgets:
+            if widget.plugin == plugin:
+                return widget
+        raise KeyError("No such widget found for %s/%s" % (hubname, plugin))
+
+    @staticmethod
+    def get_fedmsg(idx):
+        url = 'https://apps.fedoraproject.org/datagrepper/id'
+        response = requests.get(url, params=dict(id=idx))
+        if not bool(response):
+            raise IOError("Failed to talk to %r %r" % (response.url, response))
+        return response.json()
+
+
+@contextmanager
+def auth_set(APP, auth):
+    """ Set the provided user as fas_user in the provided application."""
+
+    # Hack used to remove the before_request function set by
+    # flask.ext.fas_openid.FAS which otherwise kills our effort to set a
+    # flask.g.fas_user.
+    from flask import appcontext_pushed, g
+    APP.before_request_funcs[None] = []
+
+    def handler(sender, **kwargs):
+        g.auth = auth
+        if not auth:
+            munch.Munch(logged_in=False)
+
+    with appcontext_pushed.connected_to(handler, APP):
+        yield
+
+class FakeUser(object):
+    """ Fake user used to test the fedocallib library. """
+
+    def __init__(self, username='username'):
+        """ Constructor.
+        :arg groups: list of the groups in which this fake user is
+            supposed to be.
+        """
+        self.username = username
+        self.openid = username + 'id.fedoraproject.org'
+        self.booksmarks = []
+
+    def __getitem__(self, key):
+        return self.dic[key]
+
+
+class FakeAuthorization(object):
+    """ Fake user used to test the fedocallib library. """
+
+    def __init__(self, username='username'):
+        """ Constructor.
+        :arg groups: list of the groups in which this fake user is
+            supposed to be.
+        """
+        self.logged_in = True
+        self.fullname = 'fullname: ' + username
+        self.email = 'email: ' + username
+        self.openid = username + 'id.fedoraproject.org'
+        self.user = FakeUser(username)
+        self.avatar = 'avatar_src_url'
+        self.nickname = username
+
+    def __getitem__(self, key):
+        return self.dic[key]
diff --git a/hubs/tests/test_fedora_hubs_flask_api.py b/hubs/tests/test_fedora_hubs_flask_api.py
new file mode 100644
index 0000000..bf79d06
--- /dev/null
+++ b/hubs/tests/test_fedora_hubs_flask_api.py
@@ -0,0 +1,144 @@
+import unittest
+from urlparse import urlparse
+
+from flask import json
+from os.path import dirname
+import vcr
+
+import hubs
+from hubs import tests
+from hubs.app import app
+
+import hubs.models
+
+import fedmsg.config
+
+cassette_dir = dirname(dirname(__file__)) + '/vcr-request-data/'
+
+
+class HubsAPITest(hubs.tests.APPTest):
+    @unittest.skip("Can't seem to get redirected to the login in these tests")
+    def test_index_logged_out(self):
+        result = self.app.get('/', follow_redirects=True)
+        # its trying to redirect to login id.fedoraproject.org/openid
+        # assert the status code of the response
+        self.assertEqual(result.status_code, 200)
+
+    def test_index_logged_in(self):
+        user = tests.FakeAuthorization('ralph')
+        with tests.auth_set(app, user):
+            result = self.app.get('/', follow_redirects=True)
+            # its trying to redirect to login id.fedoraproject.org/openid
+            # assert the status code of the response
+            self.assertEqual(result.status_code, 200)
+            self.assertFalse('Not logged in.  Click to <a href="/login/fedora">login</a>' in result.data)
+
+    def test_hub_logged_out(self):
+        with tests.auth_set(app, None):
+            # for some reason def check_auth() is not running and i need to set it to none so it won't crash
+            result = self.app.get('/ralph', follow_redirects=True)
+            # assert the status code of the response
+            self.assertEqual(result.status_code, 200)
+            self.assertTrue('Not logged in.  Click to <a href="/login/fedora">login</a>' in result.data)
+
+    @unittest.skip("Can't seem to get redirected to the login in these tests")
+    def test_groups_logged_out(self):
+        with tests.auth_set(app, None):
+            # for some reason def check_auth() is not running and i need to set it to none so it won't crash
+            result = self.app.get('/groups', follow_redirects=True)
+            # assert the status code of the response
+            self.assertEqual(result.status_code, 200)
+            # this will redirect to fedora.login which unittests can't handle atm
+            pass
+
+    def test_groups_logged_in(self):
+        user = tests.FakeAuthorization('ralph')
+        with tests.auth_set(app, user):
+            result = self.app.get('/groups', follow_redirects=True)
+            # assert the status code of the response
+            self.assertEqual(result.status_code, 200)
+            self.assertTrue("ZOMG -  is the Hub Of The Month!" in result.data)
+
+    def test_hub_logged_in(self):
+        user = tests.FakeAuthorization('ralph')
+        with tests.auth_set(app, user):
+            result = self.app.get('/ralph', follow_redirects=True)
+            self.assertEqual(result.status_code, 200)
+            self.assertFalse('Not logged in.  Click to <a href="/login/fedora">login</a>' in result.data)
+
+    def test_hub_json(self):
+        with tests.auth_set(app, None):
+            # for some reason def check_auth() is not running and i need to set it to none so it won't crash
+            result = self.app.get('/ralph/json', follow_redirects=True)
+            # assert the status code of the response
+            self.assertEqual(result.status_code, 200)
+            data = {
+                "avatar": "https://seccdn.libravatar.org/avatar/9c9f7784935381befc302fe3c814f9136e7a33953d0318761669b8643f4df55c?s=312&d=retro",
+                "left_width": 8,
+                "members": ["ralph"],
+                "name": "ralph",
+                "owners": ["ralph"],
+                "subscribers": [],
+                "summary": "Ralph",
+                "widgets": [31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 51]
+            }
+            self.assertDictEqual(data, json.loads(result.data))
+
+    @unittest.skip("Authorization layer not present yet")
+    def test_hub_edit_get_logged_out(self):
+        # FAILING: Authorization layer not present yet
+        with tests.auth_set(app, None):
+            result = self.app.get('/ralph/edit', follow_redirects=True)
+            self.assertEqual(result.status_code, 403)  # failing right
+            # We do not have the authorization layer in place yet
+
+    @unittest.skip("Authorization layer not present yet")
+    def test_hub_edit_get_logged_in_not_owner(self):
+        # FAILING: Authorization layer not present yet
+        user = tests.FakeAuthorization('not_ralph')
+        with tests.auth_set(app, user):
+            result = self.app.get('/ralph/edit', follow_redirects=True)
+            self.assertEqual(result.status_code, 403)  # failing right
+            # We do not have the authorization layer in place yet
+
+    def test_hub_edit_get_logged_in_owner(self):
+        user = tests.FakeAuthorization('ralph')
+        with tests.auth_set(app, user):
+            result = self.app.get('/ralph/edit', follow_redirects=True)
+            self.assertEqual(result.status_code, 200)
+            # We do not have the authorization layer in place yet so everyone can edit
+
+    @unittest.skip("Authorization layer not present yet")
+    def test_hub_edit_post_logged_out(self):
+        # FAILING: Authorization layer not present yet
+        with tests.auth_set(app, None):
+            result = self.app.post('/ralph/edit', follow_redirects=True)
+            self.assertEqual(result.status_code, 403)  # failing right
+            # We do not have the authorization layer in place yet
+
+    @unittest.skip("Authorization layer not present yet")
+    def test_hub_edit_post_logged_in_not_owner(self):
+        # FAILING: Authorization layer not present yet
+        user = tests.FakeAuthorization('not_ralph')
+        with tests.auth_set(app, user):
+            result = self.app.post('/ralph/edit', follow_redirects=True)
+            self.assertEqual(result.status_code, 403)  # failing right
+            # We do not have the authorization layer in place yet
+
+    # WIP: commenting out so I can push this updates to branch so others can contribute
+    '''
+    def test_hub_edit_post_logged_in_owner_no_data(self):
+        user = tests.FakeAuthorization('ralph')
+        with tests.auth_set(app, user):
+            result = self.app.post('/ralph/edit', follow_redirects=True)
+            self.assertEqual(result.status_code, 200)
+            assert 'Invalid widget identifiers submitted' in result.data
+            assert 'Invalid indexes submitted' in result.data
+            assert 'The number of indexes and the number of widgets ' \
+                   'are not of the same length' in result.data
+            assert 'Invalid widget identifiers submitted' in result.data
+            assert 'Invalid indexes submitted' in result.data
+    '''
+
+if __name__ == '__main__':
+    unittest.main()
diff --git a/hubs/tests/test_widgets/test_about.py b/hubs/tests/test_widgets/test_about.py
index 6890f7b..38bddee 100644
--- a/hubs/tests/test_widgets/test_about.py
+++ b/hubs/tests/test_widgets/test_about.py
@@ -1,5 +1,7 @@
 import json
 
+from nose.tools import assert_dict_equal
+
 import hubs.tests.test_widgets
 
 
@@ -17,3 +19,32 @@ class TestBadges(hubs.tests.test_widgets.WidgetTest):
             u'source_url': u'/source/about',
             u'text': u'Testing.',
         })
+
+    def test_should_invalidate_wrong_topic(self):
+        widget = self.widget_instance('ralph', self.plugin)
+        msg = {'topic': 'hubs.widget.update.WRONG.TOPIC', 'msg': {'widget': {'id': widget.idx}}}
+        module = hubs.widgets.registry[widget.plugin]
+        result = module.should_invalidate(msg, self.session, widget)
+        assert not result
+
+    def test_should_invalidate_wrong_widget_id(self):
+        widget = self.widget_instance('ralph', self.plugin)
+        msg = {'topic': 'hubs.widget.update', 'msg': {'widget': {'id': widget.idx+1}}}
+        module = hubs.widgets.registry[widget.plugin]
+        result = module.should_invalidate(msg, self.session, widget)
+        assert not result
+
+    def test_should_invalidate_good_match(self):
+        widget = self.widget_instance('ralph', self.plugin)
+        msg = {'topic': 'hubs.widget.update', 'msg': {'widget': {'id': widget.idx}}}
+        module = hubs.widgets.registry[widget.plugin]
+        result = module.should_invalidate(msg, self.session, widget)
+        assert result
+
+    '''
+    def test_data(self):
+        widget = self.widget_instance('ralph', self.plugin)
+        module = hubs.widgets.registry[widget.plugin]
+        result = module.data(self.session, widget, 'I love oss.')
+        assert_dict_equal({'text': 'I love oss.'}, result)
+    '''
\ No newline at end of file
diff --git a/hubs/tests/test_widgets/test_badges.py b/hubs/tests/test_widgets/test_badges.py
index 4f668b1..7edd96e 100644
--- a/hubs/tests/test_widgets/test_badges.py
+++ b/hubs/tests/test_widgets/test_badges.py
@@ -1,5 +1,6 @@
 import json
 
+from mock import patch, MagicMock
 import hubs.tests.test_widgets
 
 
@@ -16,21 +17,68 @@ class TestBadges(hubs.tests.test_widgets.WidgetTest):
 
     def test_should_invalidate_wrong_topic(self):
         widget = self.widget_instance('ralph', self.plugin)
-        msg = self.get_fedmsg('2016-ebb84660-59e9-4e68-af8f-4e6f49348b88')
+        # msg = self.get_fedmsg('2016-ebb84660-59e9-4e68-af8f-4e6f49348b88')
+        msg = {'topic': 'hubs.widget.update.WRONG.TOPIC'}
         module = hubs.widgets.registry[widget.plugin]
         result = module.should_invalidate(msg, self.session, widget)
         assert not result
 
     def test_should_invalidate_wrong_user(self):
         widget = self.widget_instance('ralph', self.plugin)
-        msg = self.get_fedmsg('2016-e371c7f6-bc8e-4632-8e33-b9102dc30b5f')
+        # msg = self.get_fedmsg('2016-e371c7f6-bc8e-4632-8e33-b9102dc30b5f')
+        msg = {'topic': 'fedbadges.badge.award', 'msg': {'user': {'username': 'not_ralph'}}}
         module = hubs.widgets.registry[widget.plugin]
         result = module.should_invalidate(msg, self.session, widget)
         assert not result
 
-    def test_should_invalidate_good_match(self):
+    def test_should_invalidate_good_match_fedbadges(self):
         widget = self.widget_instance('ralph', self.plugin)
-        msg = self.get_fedmsg('2016-1fbb1135-681b-4d3b-9a40-d0f6ebd313f4')
+        # msg = self.get_fedmsg('2016-1fbb1135-681b-4d3b-9a40-d0f6ebd313f4')
+        msg = {'topic': 'fedbadges.badge.award', 'msg': {'user': {'username': 'ralph'}}}
         module = hubs.widgets.registry[widget.plugin]
         result = module.should_invalidate(msg, self.session, widget)
         assert result
+
+    def test_should_invalidate_good_match_hubswidget(self):
+        widget = self.widget_instance('ralph', self.plugin)
+        # msg = self.get_fedmsg('2016-1fbb1135-681b-4d3b-9a40-d0f6ebd313f4')
+        msg = {'topic': 'hubs.widget.update', 'msg': {'widget': {'id': widget.idx + 1}}}
+        module = hubs.widgets.registry[widget.plugin]
+        result = module.should_invalidate(msg, self.session, widget)
+        assert result
+    '''
+    @patch('requests.get')
+    @patch('hubs.widgets.base.cache.get_or_create')
+    def test_data_good(self, cache_mock, requests_mock):
+        requests_mock.return_value = self.mock_response()
+        cache_mock.return_value = None
+        widget = self.widget_instance('ralph', self.plugin)
+        module = hubs.widgets.registry[widget.plugin]
+        result = module.data(self.session, widget, 'ralph')
+        assert result
+    '''
+    @staticmethod
+    def mock_response():
+        test_data_simple = '''{
+            "percent_earned": 47.05882352941176,
+            "assertions": [{
+                "description": "You attended Flock 2014, the Fedora Contributor Conference",
+                "tags": "flock,event,",
+                "issued": 1375373082.0,
+                "image": "https://badges.fedoraproject.org/pngs/flock-2013-attendee.png",
+                "first_awarded": 1375373082.0,
+                "first_awarded_person": "ralph",
+                "last_awarded_person": "gnokii",
+                "last_awarded": 1386188828.0,
+                "percent_earned": 0.404551201011378,
+                "id": "flock-2013-attendee",
+                "times_awarded": 80,
+                "name": "Flock 2013 Attendee"
+            }],
+            "user": "ralph",
+            "avatar": ""
+        }'''
+
+        mock = MagicMock()
+        mock.json.return_value = json.loads(test_data_simple)
+        return mock
diff --git a/hubs/tests/test_widgets/test_meetings.py b/hubs/tests/test_widgets/test_meetings.py
index 90656fd..bafb6a3 100644
--- a/hubs/tests/test_widgets/test_meetings.py
+++ b/hubs/tests/test_widgets/test_meetings.py
@@ -20,4 +20,4 @@ class TestMeetings(hubs.tests.test_widgets.WidgetTest):
         widget = self.widget_instance(team, self.plugin)
         response = self.app.get('/%s/%i/' % (team, widget.idx))
         assert response.status_code == 200, response.status_code
-        assert 'The i18n meeting is in' in response.data, response.data
+        assert 'The i18n meeting is ' in response.data, response.data
diff --git a/hubs/widgets/about.py b/hubs/widgets/about.py
index c1ff1f6..7023139 100755
--- a/hubs/widgets/about.py
+++ b/hubs/widgets/about.py
@@ -21,6 +21,6 @@ def data(session, widget, text):
 def should_invalidate(message, session, widget):
     if not message['topic'].endswith('hubs.widget.update'):
         return False
-    if message['msg']['widget']['id'] != widget.id:
+    if message['msg']['widget']['id'] != widget.idx:
         return False
     return True
diff --git a/hubs/widgets/badges.py b/hubs/widgets/badges.py
index c5a18d0..abf4b15 100755
--- a/hubs/widgets/badges.py
+++ b/hubs/widgets/badges.py
@@ -30,7 +30,7 @@ def data(session, widget, username):
 @hint(topics=[_('hubs.widget.update'), _('fedbadges.badge.award')])
 def should_invalidate(message, session, widget):
     if message['topic'].endswith('hubs.widget.update'):
-        if message['msg']['widget']['id'] != widget.id:
+        if message['msg']['widget']['id'] != widget.idx:
             return True
 
     if message['topic'].endswith('fedbadges.badge.award'):

